Program Eliza (input,output);
(*The computer psychiatrist: searches input strings for recognized 
words and tries to respond appropriately.*)
(*Based on the programs which have been in public domain for many years.*)
(*Travis Crawford*)
(*HighSpeed (Atari) and Turbo (PC) Pascal versions: Dec. 23, 1995*)
(*Modified for XLP (UNIX): Nov/Dec 1996. Differences in versions are
    indicated using curled-bracket comments, as in next line.*)

{XLP does not use units}
uses CRT,DOS; 

type
  {XLP uses the syntax "string(5)" instead of "string[5]" for defining
     string lengths. Some of the following strings could be given shorter
     lengths to conserve memory.}
  charstrtype=string;
  keywordstrtype=string;
  replystrtype=string;
  inputstrtype=string;
  outputstrtype=string;
  conjstrtype=string;
  keywordtype=^keywordrectype;
  replytype=^replyrectype;
  conjtype=^conjrectype;
  keywordrectype=record
                 keyword:keywordstrtype;
                 replies:replytype;
                 nextkeyword:keywordtype;
               end; (*keywordrectype*)
  replyrectype=record
                 reply:replystrtype;
                 nextreply:replytype;
               end; (*replyrectype*)
  conjrectype=record
                inword,outword:conjstrtype;
                nextconj:conjtype;
              end; (*conjrectype*)
  datafiletype=text;
  
var
  keywords:keywordtype;
  conj:conjtype;
  datafilename:string;
  elizadat:datafiletype;
  debugstr:string; 
  D1,D2,D3,D4:boolean; (*debug flags*)


(*--------------------------------------------------------------------*)
function copy (fromstr:inputstrtype; pos,lengthnew:integer):inputstrtype;
(*makes xlp compatible with Turbo's copy command: 
    tempstr:=copy(inputstr,pos1,length(tempkeyword^.keyword)); *)
(*Won't return empty string?*)

const DC=false;

var
  newstr:inputstrtype;
  charstr:charstrtype;
  i:integer;

begin
  newstr:='';
  charstr:='*';
  if (pos>0) and (pos<=length(fromstr)) and (lengthnew>0)
    then for i:=pos to pos+lengthnew-1 do
      begin    
        if DC then Write ('For fromstr position #',i:2);
        if i<=length(fromstr)
          then begin
            if DC then Writeln (', about to put ->',fromstr[i],
                                          '<- into newstr.'); 
            charstr[1]:=fromstr[i];
            newstr:=newstr+charstr;
          end
          else if DC then Writeln (', went beyond length for fromstr.'); 
                                                                 (*if*)
      end
      else if DC then  Writeln ('pos is above length(fromstr) or = 0');
                                                                  (*if,for*)
  if DC then Writeln ('About to set copy equal to ->',newstr,'<-');
  copy:=newstr;
  if DC then Writeln ('Now exiting copy function');
end; (*copy*) 

(*--------------------------------------------------------------------*)
Procedure insert (var outword:outputstrtype;  var remstr:outputstrtype; 
                        pos1:integer);
(*Compatibility command for Turbo:
         insert (tempconj^.outword,remstr,pos1); *)

const
  DI=false;

var
  tempstr:outputstrtype;

begin
  if DI then begin
    Writeln ('First part is ->',copy (remstr,1,pos1-1),'<-');
    Writeln ('Second part   ->',outword,'<-');
    Writeln ('Third part is ->',copy 
                           (remstr,pos1,length(remstr)-pos1+1),'<-');
  end; (*if*)
  remstr:=copy(remstr,1,pos1-1)+outword+
          copy(remstr,pos1,length(remstr)-pos1+1);
end; (*insert*)

(*-------------------------------------------------------------------*)

Procedure delete (var remstr:outputstrtype; pos1,len: integer);
(*Compatibility:  delete (remstr,pos1,length(tempconj^.inword)); *)

const
  DD=false;

begin
  if DD then begin
     Writeln ('First part is  ->',copy(remstr,1,pos1-1),'<-');
     Writeln ('Second part is ->',
                      copy(remstr,pos1+len,length(remstr)-pos1-len+1),'<-');
  end; (*if*)
  remstr:=copy(remstr,1,pos1-1)+
                       copy(remstr,pos1+len,length(remstr)-pos1-len+1);
end; (*delete*)

(*-------------------------------------------------------------------*)

Procedure testsubs;
(*test the copy/insert/delete procedures *)

var
  stri1,stri2:inputstrtype;
  stro1,stro2:outputstrtype;
  num1,num2,i,j:integer;

begin
  stri1:='Copy the word hello from this string';
  Writeln ('stri1 is ->',stri1,'<-');
  stri2:=copy(stri1,15,5);
  Writeln ('stri2 is ->',stri2,'<-');
  Writeln ('Insert stri2 into stri1 at pos 31');
  insert (stri2,stri1,31);
  Writeln ('stri1 is now ->',stri1,'<-');
  Writeln ('Delete "word" from stri1');
  delete (stri1,10,5);
  Writeln ('stri1 is now ->',stri1,'<-');
  Writeln ('End of testnewprocs');
end; (*testsubs*)

(*-------------------------------------------------------------------*)
Procedure Showdata (keywords:keywordtype; conj:conjtype);
(*For debugging: shows what's in memory*)

Const
  LIMIT=5; (*how many replies to show*)

var
  keywordnum,replynum,conjnum:integer;
  tempkeyword:keywordtype;
  tempreply:replytype;
  tempconj:conjtype;

begin
  Writeln ('~~ This is the data currently stored in memory ~~');
  tempkeyword:=keywords;
  keywordnum:=0;
  while not (tempkeyword=nil) do
    begin
      keywordnum:=keywordnum+1;
      Writeln ('KEYWORD #',keywordnum:2,' >',tempkeyword^.keyword,'<');
      tempreply:=tempkeyword^.replies;
      replynum:=0;
      while (not (tempreply=nil)) and (replynum<LIMIT) do
        begin
          replynum:=replynum+1;
          Writeln ('  REPLY #',replynum:2,' >',tempreply^.reply,'<');
          tempreply:=tempreply^.nextreply;
        end; (*while*)
      if replynum=LIMIT
        then Writeln ('            -(limit reached)-');
      tempkeyword:=tempkeyword^.nextkeyword;
    end; (*while*)
  conjnum:=0;
  tempconj:=conj;
  while not (tempconj=nil) do
    begin
      conjnum:=conjnum+1;
      Writeln ('   CONJ #',conjnum:2,' >',tempconj^.inword,'< >',tempconj^.outword,'<');
      tempconj:=tempconj^.nextconj;
    end; (*while*)
  Writeln ('~~ End of data in memory ~~');
end;(*showdata*)

(*------------------------------------------------------------------*)
Procedure Readdata(var keywords:keywordtype; var conj:conjtype;
                                      var datafile:datafiletype);
(*reads data in from the data file*)

var
  elizadat:datafiletype;
  ch:char;
  errorfound,defreplyfound:boolean;
  prevkeyword,tempkeyword:keywordtype;
  firstreply,tempreply:replytype;
  prevconj,tempconj:conjtype;
  tempstr:string;
  i:integer;
  
begin
  i:=0;
  defreplyfound:=false;
  errorfound:=false;
  reset (datafile);
  Writeln ('~~ Now reading Datafile ~~');
  repeat
    read (datafile,ch);
    i:=i+1;
    if D1 then Writeln ('A character has been read (#.',i:4,')');
    if not eof(datafile)
      then begin
        if (ch='?') then begin
                if D1 then Writeln ('A keyword has been read');
                if not defreplyfound 
                  then begin (*if a keyword was read before a default reply*)
                    Writeln ('ERROR: There are no default replies in the file!');
                    Writeln ('(Default replies must occur as "!<reply>" lines'); 
                    Writeln ('before the first "?<keyword>" line in the file!)');
                    Writeln ('Press RETURN to abort program.....');
                    readln;
                    close(datafile);
                    halt; (*aborts program*)
                  end; (*if*)
                new (tempkeyword);
                readln (datafile,tempkeyword^.keyword);
                tempkeyword^.replies:=nil;
                tempkeyword^.nextkeyword:=keywords;
                keywords:=tempkeyword;
              end; (*?*)
        if (ch='!') then begin
                if D1 then Writeln ('A reply has been read');
                defreplyfound:=true;
                new (tempreply);
                readln(datafile,tempreply^.reply);
                tempreply^.nextreply:=keywords^.replies;
                keywords^.replies:=tempreply;
              end; (*if !*)
        if (ch='<') then begin
                if D1 then Writeln ('an inword has been read');
                new (tempconj);
                readln (datafile,tempconj^.inword);
                tempconj^.outword:='';
                tempconj^.nextconj:=nil;
                tempconj^.nextconj:=conj;
                conj:=tempconj;
              end; (*<*)
        if (ch='>') then begin
                if D1 then writeln ('an outword has been read');
                readln (datafile,conj^.outword);
                if conj^.inword='NOCONJFOUND'
                  then begin (*no matching inword*)
                    Writeln ('No conjugation was found to match with ',conj^.outword,'.');
                    errorfound:=true;
                    conj^.outword:='NOCONJFOUND';
                  end; (*if*)
              end; (*>*)
        if (ch='#') then begin
                if D1 then writeln ('a comment-out had been read');
                readln (datafile,tempstr); (* # is a comment-out character*);
              end; (*#*)
      end; (*if not*)
  until eof(datafile);
  close (datafile);
  Writeln ('~~ Finished reading datafile ~~');
  if D1 then showdata (keywords,conj);
  if D2 then Writeln ('~~ Now sorting out keywords without immediate replies ~~');
  tempkeyword:=keywords;
  while (tempkeyword^.replies=nil) do (*no replies for words at end of file*)
    begin
      Writeln ('No replies found for keyword "',tempkeyword^.keyword,'".');
      errorfound:=true;
      keywords:=keywords^.nextkeyword;
      dispose (tempkeyword); (*remove keyword*)
      tempkeyword:=keywords;
    end; (*while*)
  prevkeyword:=keywords; (*this keyword has replies*)
  tempkeyword:=keywords;
  while not (tempkeyword=nil) do
    begin
      if tempkeyword^.replies=nil
        then tempkeyword^.replies:=prevkeyword^.replies;
      prevkeyword:=tempkeyword;
      tempkeyword:=tempkeyword^.nextkeyword;
    end;(*while*)
  tempconj:=conj;
  prevconj:=conj;
  while not (tempconj=nil) do
    begin
      if tempconj^.outword='' (*no outword found for this inword*)
        then tempconj^.outword:=prevconj^.outword;
      prevconj:=tempconj;
      tempconj:=tempconj^.nextconj;
    end; (*while*)
  
  if D2 then showdata (keywords,conj);
  if D2 then Writeln ('~~ Now looping the replies ~~');
  tempkeyword:=keywords;
  repeat
      tempreply:=tempkeyword^.replies;
      firstreply:=tempreply;
      while (not (tempreply^.nextreply=nil)) 
                          and (not (firstreply=tempreply^.nextreply)) do
        tempreply:=tempreply^.nextreply;
      tempreply^.nextreply:=tempkeyword^.replies;
      tempkeyword:=tempkeyword^.nextkeyword;
  until tempkeyword=nil;
  if errorfound
    then begin
      Writeln ('Press return to continue....');
      readln;
    end; (*if*)
  if D2 then showdata (keywords,conj);
end; (*readdata*)

(*-------------------------------------------------------------------*)
Procedure Mainloop (keywords:keywordtype; conj:conjtype);
(*Inputs a string from the user, analyzes it and replies.*)

var
  respfound:boolean;
  inputstr,tempstr:inputstrtype;
  replystr,remstr:outputstrtype;
  tempconj:conjtype;
  tempkeyword:keywordtype;
  punct:charstrtype;
  pos1:integer;
  
begin
  {XLP does not use clrscr (from CRT unit in Turbo)}
  if not (D1 or D2 or D3 or D4) then clrscr; 
  if D3 then Writeln ('~~ Now in main loop ~~');
  Writeln ('HI.  I''M ELIZA.  WHAT''S YOUR PROBLEM?');
  Writeln;
  repeat
    Write (':');
    readln (inputstr);
    inputstr:=' '+inputstr+' '; (*add spaces so keywords with trailing spaces will be found*)
    for pos1:=1 to length(inputstr) do
      if (ord(inputstr[pos1])>=97) and (ord(inputstr[pos1])<=122)
        then inputstr[pos1]:=chr( ord(inputstr[pos1]) - 32); (*for,if (upcase)*)
    
    (*future version of prrgram: could put in a menu for options (print, etc.) *)
    
    respfound:=false;
    tempkeyword:=keywords;
    while (tempkeyword^.nextkeyword<>nil) and (not respfound) do
      begin
        if D3 then Writeln ('searching input for keyword >',tempkeyword^.keyword,'<');
        if length(inputstr)>=(length(tempkeyword^.keyword)) 
          then begin
            pos1:=1;
            while (pos1<=(length(inputstr)-length(tempkeyword^.keyword)+1)) and (not respfound) do
              begin
                tempstr:=copy(inputstr,pos1,length(tempkeyword^.keyword));
                if D3 then Writeln ('checking tempstr >',tempstr,'<');
                if tempstr=tempkeyword^.keyword
                  then begin
                    respfound:=true;
                    if D3 then Writeln ('Response found!');
                    replystr:=tempkeyword^.replies^.reply;
                    tempkeyword^.replies:=tempkeyword^.replies^.nextreply;
                  end; (*if*)
                pos1:=pos1+1;
              end; (*for*)
            end; (*if length*)
        if not respfound
          then tempkeyword:=tempkeyword^.nextkeyword; (*move on to next keyword*)
      end; (*while*)
    if tempkeyword^.nextkeyword=nil (*use default*)
      then begin
        if D3 then Writeln ('no response found. using default from >',tempkeyword^.keyword,'<');
        pos1:=1;
        replystr:=tempkeyword^.replies^.reply;
        tempkeyword^.replies:=tempkeyword^.replies^.nextreply;
      end; (*if*)
    
    if replystr[length(replystr)-1]='*'
      then begin (*replace * with rest of input*)
        if D4 then Writeln ('now replacing * with rest of input');
        if pos1<>1
          then pos1:=pos1+length(tempkeyword^.keyword)-1;
        remstr:=copy(inputstr,pos1,length(inputstr)-pos1+2);
        if D4 then writeln ('remstr is now >',remstr,'<');
        if length(remstr)>0 (*don't remove chars if nothing in remstr*)
          then begin 
            if D4 then writeln ('now removing added space');
            remstr:=copy(remstr,1,length(remstr)-1);(*remove the added space*)
            if length(remstr)>0 then
              if remstr[length(remstr)] in ['?','.','!']
                then begin
                       if D4 then writeln ('now removing punctuation');
                       remstr:=copy(remstr,1,length(remstr)-1);(*remove punct from input*)
                 end; (*remove punct*)
            remstr:=remstr+' '; (*add space again*)
          end; (*if*)
        pos1:=1;   (*now look for conjugations*)
        while pos1<length(remstr) do
          begin
            tempconj:=conj;
            while (tempconj<>nil) do (*check current pos for all conj*)
              begin
                if D4 then Writeln ('looking for inword >',tempconj^.inword,'<');
                if length(remstr)>=pos1+length(tempconj^.inword)-1
                  then begin
                    tempstr:=copy(remstr,pos1,length(tempconj^.inword));
                    if D4 then Writeln ('  checking tempstr >',tempstr,'<');
                    if tempstr=tempconj^.inword
                      then begin
                        if D4 then Writeln ('Conj found! >',tempconj^.outword,'<');
                        delete (remstr,pos1,length(tempconj^.inword));
                        insert (tempconj^.outword,remstr,pos1);
                        pos1:=pos1+length(tempconj^.outword)-2;
                      end; (*if =*)
                  end; (*if length*)
                tempconj:=tempconj^.nextconj;
              end; (*while <>*)
            pos1:=pos1+1;
          end; (*while <*)
        if length(remstr)>0
          then remstr:=copy(remstr,1,length(remstr)-1);(*remove space again*)
        if D4 then Writeln ('remstr is now >',remstr,'<');
        punct:=copy(replystr,length(replystr),1);
        replystr:=copy(replystr,1,length(replystr)-2);(*remove * and punctuation from reply*)
        if D4 then Writeln ('replystr is now >',replystr,'<');
        replystr:=replystr+remstr+punct;
      end;
    
    if (D3 or D4) then Writeln ('final reply >',replystr,'<')
          else if (inputstr<>' QUIT ') and (inputstr<>' EXIT ')
                 then Writeln (replystr); (*response is finally displayed*)
  until (inputstr=' QUIT ') or (inputstr=' EXIT ');
end; (*mainloop*)

(*-------------------------------------------------------------------*)
  
begin
  debugstr:='*DEBUG FLAGS >FFFF<*';(*modify to turn on/off debug messages*)
                                   (*this string appears in compiled program code*)
  
  {XLP does not support command line parameters via paramstr, thus the datafilename
    and debug flags must be overridden. Also, XLP does not use the ASSIGN
    command, and will use the name of the file variable (eg. "elizadat") in 
    commands like "read (elizadat,ch)" as the file name itself.}
  
  datafilename:=paramstr(1);                 (*get parameter from command line*)
  D1:=(debugstr[15]='T')or(paramstr(2)='T'); (*info while loading*)
  D2:=(debugstr[16]='T')or(paramstr(3)='T'); (*info while processing memory*)
  D3:=(debugstr[17]='T')or(paramstr(4)='T'); (*info while finding reply*)
  D4:=(debugstr[18]='T')or(paramstr(5)='T'); (*info while including input text in output*)  
{  D1:=false; D2:=false; D3:=false; D4:=false;}
{  datafilename:='';}
  if datafilename='' then datafilename:='ELIZA.DAT   ';
  assign (elizadat,datafilename); 
  Writeln ('~~ Datafile being used is: ',datafilename,' ~~'); 
  
  (*initialize data set*)
  new (keywords);
  keywords^.keyword:='NOKEYFOUND';
  keywords^.replies:=nil;
  keywords^.nextkeyword:=nil;
  new (conj);
  conj^.inword:='NOCONJFOUND';
  conj^.outword:='NOCONJFOUND';
  conj^.nextconj:=nil;
  
  readdata (keywords,conj,elizadat);
  mainloop (keywords,conj);
end.
